<?php

//  define('SHOW_VARIABLES', 1);
//  define('DEBUG_LEVEL', 1);

//  error_reporting(E_ALL ^ E_NOTICE);
//  ini_set('display_errors', 'On');

set_include_path('.' . PATH_SEPARATOR . get_include_path());


require_once 'components/utils/system_utils.php';

//  SystemUtils::DisableMagicQuotesRuntime();

SystemUtils::SetTimeZoneIfNeed('Australia/Canberra');

function GetGlobalConnectionOptions()
{
    return array(
  'server' => 'localhost',
  'port' => '3306',
  'username' => 'vufind',
  'password' => 'vufind',
  'database' => 'vufind'
);
}

function HasAdminPage()
{
    return false;
}

function GetPageInfos()
{
    $result = array();
    $result[] = array('caption' => 'Home', 'short_caption' => 'EvolvePlus Vufind Manager', 'filename' => 'index.php', 'name' => 'index');
    $result[] = array('caption' => 'Comments', 'short_caption' => 'VuFind Comments by Users', 'filename' => 'vufind_comments.php', 'name' => 'comments');
    $result[] = array('caption' => 'Tag Authorities', 'short_caption' => 'VuFind Tag Authority List', 'filename' => 'vufind_tags.php', 'name' => 'tags');
    $result[] = array('caption' => 'Tags Applied', 'short_caption' => 'VuFind Tags Applied to Catalogue', 'filename' => 'vufind_resource_tags.php', 'name' => 'resource_tags');
    $result[] = array('caption' => 'Users', 'short_caption' => 'VuFind Registered Users', 'filename' => 'vufind_user.php', 'name' => 'user');
    return $result;
}

function GetPagesHeader()
{
    return
    '<big><b>EvolvePlus VuFind Manager</b></big><br>
<small>Version 1.0.3</small>';
}

function GetPagesFooter()
{
    return
        '<small>&nbsp;  2012 <a href="http://www.evolveplus.com.au" target="_blank">EvolvePlus Pty Ltd</a><br>
&nbsp;&nbsp;&nbsp;&nbsp; All rights reserved.</small>'; 
    }

function ApplyCommonPageSettings($page, $grid)
{
    $page->SetShowUserAuthBar(false);
    $grid->BeforeUpdateRecord->AddListener('Global_BeforeUpdateHandler');
    $grid->BeforeDeleteRecord->AddListener('Global_BeforeDeleteHandler');
    $grid->BeforeInsertRecord->AddListener('Global_BeforeInsertHandler');
}

/*
  Default code page: 1252
*/
function GetAnsiEncoding() { return 'windows-1252'; }

function Global_BeforeUpdateHandler($page, $rowData, &$cancel, &$message, $tableName)
{

}

function Global_BeforeDeleteHandler($page, $rowData, &$cancel, &$message, $tableName)
{

}

function Global_BeforeInsertHandler($page, $rowData, &$cancel, &$message, $tableName)
{

}

function GetDefaultDateFormat()
{
    return 'Y-m-d';
}
?>